{*******************************}
{* Mensfeld Maciej             *}
{* 03.03.2007                  *}
{* Ruchome figury geometryczne *}
{*******************************}

unit uFigury;
interface
 type
  { typ tablicowy tablic polozenia trojkatow }
  Trojkaty = array[0..2, 0..1] of integer;
  { typ tablicowy tablic polozenia prostokatow }
  Prostokaty = array[0..3, 0..1] of integer;

 procedure poruszaj
 (xP, yP, odlX, odlY, kier, kat, polozenie : integer; var x, y : integer);

 procedure trojkat
 (polozenie, xP, yP, odlX, odlY, kier, kat : integer; var tab : Trojkaty);

 procedure okrag
 (xP, yP, odlX, odlY, kier, kat, polozenie, kolor : integer;
                                        var x, y : integer);

 procedure elipsa
 (xP, yP, odlX, odlY, kier, kat, polX, polY : integer;
                  stopien : real; var x, y : integer);

 procedure prostokat
 (xP,yP, odlX, odlY, kier, kat, polozenie : integer; var  tab : Prostokaty);

 procedure figury
 (x, y : integer);

implementation
 uses Crt, Graph;

 { ----------------------- PORUSZAJ ---------------------------------------- }
procedure poruszaj
(xP, yP, odlX, odlY, kier, kat, polozenie : integer; var x, y : integer);
{ xPrzeksztalcania, yPrzeksztalcania, odleglosc od xP, odl. od yP,
  kierunek (1 w prawo, -1 w lewo), kat - miara kata przeksztalcania,
  polozenie - odchylenie punktu od pionu }
const
 stopien = (2 * Pi) / 360;
begin
   x := Round(xP + odlX * sin((kier * kat + polozenie) * stopien));
   y := Round(yP + odlY * cos((kier * kat + polozenie) * stopien));
end;
{ ----------------------- Koniec Poruszaj --------------------------------- }

{ ----------------------- Trojkat ----------------------------------------- }
procedure trojkat
(polozenie, xP, yP, odlX, odlY, kier, kat : integer; var tab : Trojkaty);
begin
   { Okresl polozenie wierzcholka gornego trojkata }
   poruszaj(xP, yP, odlX, odlY, kier, kat, polozenie, tab[0, 0], tab[0, 1]);
   { i dwoch bocznych }
   poruszaj(xP, yP, odlX, odlY, kier,
            kat, polozenie - 120, tab[1, 0], tab[1, 1]);
   poruszaj(xP, yP, odlX, odlY, kier,
            kat, polozenie - 240, tab[2, 0], tab[2, 1]);
   { polacz wierzcholki tworzac trojkat }
   Line(tab[0,0], tab[0,1], tab[1,0], tab[1,1]);
   Line(tab[1,0], tab[1,1], tab[2,0], tab[2,1]);
   Line(tab[2,0], tab[2,1], tab[0,0], tab[0,1]);
end;
{ ---------------------- Koniec Trojkat ----------------------------------- }

{ ---------------------- Poczatek Okrag --------------------------------- }
procedure okrag (xP, yP, odlX, odlY, kier, kat,
                 polozenie, kolor : integer; var x, y : integer);
begin
 { okresala polozenie punktu w zaleznosci od kata }
 { aby rysowalo nieznikajacy okrag zapetlic od 0 do 360 }
 poruszaj(xP, yP, odlX, odlY, kier, kat, polozenie, x, y);
 PutPixel(x, y, kolor);
end;
{ ---------------------- Koniec Okrag ----------------------------------- }


{ ---------------------- Poczatek Elipsa ---------------------------------- }
   { dziala analogicznie do okregu tylko pozwala na formowanie elips }
   { zapetlic tak samo }
procedure elipsa(xP, yP, odlX, odlY, kier, kat,
                 polX, polY : integer; stopien : real; var x, y : integer);
begin
 x := Round(xP + odlX * sin((kier * kat + polX) * stopien));
 y := Round(yP + odlY * cos((kier * kat + polY) * stopien));
 PutPixel(x, y, 1);  { zeby bylo widac srodek okregu }
end;
{ ---------------------- Koniec Elipsa ------------------------------------ }

{ ---------------------- Poczatek prostokat ------------------------------- }
procedure prostokat
(xP,yP, odlX, odlY, kier, kat, polozenie : integer; var  tab : Prostokaty);
begin
 { okresl polozenie 4 rogow }
 poruszaj(xP, yP, odlX, odlY, kier, kat, polozenie - 135, tab[0,0], tab[0,1]);
 poruszaj(xP, yP, odlX, odlY, kier, kat, polozenie + 135, tab[1,0], tab[1,1]);
 poruszaj(xP, yP, odlX, odlY, kier, kat, polozenie + 45, tab[2,0], tab[2,1]);
 poruszaj(xP, yP, odlX, odlY, kier, kat, polozenie - 45, tab[3,0], tab[3,1]);
 { i polacz je zeby miec prostokat }
 Line(tab[0,0], tab[0,1], tab[1,0], tab[1,1]);
 Line(tab[1,0], tab[1,1], tab[2,0], tab[2,1]);
 Line(tab[2,0], tab[2,1], tab[3,0], tab[3,1]);
 Line(tab[3,0], tab[3,1], tab[0,0], tab[0,1]);
end;
{ ---------------------- Koniec prostokat --------------------------------- }

procedure figury(x, y : integer);
var
 kat, katElips, katS : integer;
 tabT { tablica duzych trjkatow} : Trojkaty;
 tabElips : array [0..21, 0..1] of integer;
 tabKwadr : Prostokaty;
const
 stopien = (2 * Pi) / 360;
begin
 { powtarzaj od 0 do 360 stopni (czyli niech wszystko sie obroci do 360 ) }
 for kat := 0 to 360 do
  begin
   Clearviewport; {czysc ekran }
   {rysuj kwadraty - na poczatku zeby byly " w tle" i zeby nie mrugaly }
   prostokat(x div 2, y div 2, 250, 250,  1, kat * 4, 45, tabKwadr);
   prostokat(x div 2, y div 2, 250, 250, -1, kat * 4, 45, tabKwadr);
   { trojkaty srodkowe }
   trojkat(180, (x div 2), (y div 2), 100, 100, 1, kat, tabT);
   trojkat(180, (x div 2), (y div 2), 100, 100, - 1, kat, tabT);
   { "tory" kolowe dla okregow z wierzcholkow trojkowatow }
   okrag(tabT[0,0], tabT[0, 1], 20, 20, 1,
        kat * 10, 0, 3, tabElips[0,0], tabElips[0,1]);
   okrag(tabT[1,0], tabT[1, 1], 20, 20,  1,
        kat * 10, -120, 3, tabElips[2,0], tabElips[2,1]);
   okrag(tabT[2,0], tabT[2, 1], 20, 20,  1,
        kat * 10, -240, 3, tabElips[4,0], tabElips[4,1]);
   { okregi krazace po torach wokol wierzcholkow trojkata }
   { te male "przypiete" do trojkatow }
   for katElips := 1 to 360 do
    begin
     okrag(tabElips[0,0], tabElips[0,1], 20,
          20, 1, katElips, 0, 3, tabElips[1,0], tabElips[1,1]);
     okrag(tabElips[2,0], tabElips[2,1], 20,
          20, 1, katElips, 0, 3, tabElips[3,0], tabElips[3,1]);
     okrag(tabElips[4,0], tabElips[4,1], 20,
          20, 1, katElips, 0, 3, tabElips[5,0], tabElips[5,1]);
    end;
   { tory eliptyczne dla okregow "goniacych" }
   elipsa((x div 2), (y div 2), 400, 250, 1, kat * 2, + 45, 0, stopien,
          tabElips[6,0], tabElips[6,1]);
   elipsa((x div 2), (y div 2), 400, 250, -1, kat * 2, - 45, 0, stopien,
          tabElips[8,0], tabElips[8,1]);
   elipsa((x div 2), (y div 2), 400, 250, -1, kat * 3, 0, 180, stopien,
          tabElips[10,0], tabElips[10,1]);
   elipsa((x div 2), (y div 2), 400, 250,  1, kat * 3, 0, 180, stopien,
          tabElips[12,0], tabElips[12,1]);
   { tory kolowe dla elips malych krazacych naookolo trojkatow }
   elipsa((x div 2), (y div 2), 400, 400,  1, kat, 0, 180, stopien,
          tabElips[14,0], tabElips[14,1]);
   elipsa((x div 2), (y div 2), 400, 400, - 1, kat, 0, 180, stopien,
          tabElips[16,0], tabElips[16,1]);
   { tory eliptyczne dla okregow krazacych wokolo elips malych widocznych }
   elipsa(tabElips[14,0], tabElips[14,1], 50, 25, - 1, kat, 0, 180, stopien,
           tabElips[18,0], tabElips[18,1]);
   elipsa(tabElips[16,0], tabElips[16,1], 50, 25,  1, kat, 0, 180, stopien,
           tabElips[20,0], tabElips[20,1]);
   { okregi krazace wokolo torow eliptycznych malych }
   for katElips := 1 to 360 do
    begin
     okrag(tabElips[18,0], tabElips[18,1], 15,
           15, 1, katElips, 0,8, tabElips[19,0], tabElips[19,1]);
     okrag(tabElips[20,0], tabElips[20,1], 15,
           15, 1, katElips, 0,8, tabElips[21,0], tabElips[21,1]);
    end;
   for katElips := 1 to 360 do
    begin
     { okregi male - czerwone goniace po torach eliptycznych }
     okrag(tabElips[6,0], tabElips[6,1], 25,
           25, 1, katElips, 0,4, tabElips[7,0], tabElips[7,1]);
     okrag(tabElips[8,0], tabElips[8,1], 25,
           25, 1, katElips, 0,4, tabElips[9,0], tabElips[9,1]);
     okrag(tabElips[10,0], tabElips[10,1], 25,
           25, 1, katElips, 0,4, tabElips[11,0], tabElips[11,1]);
     okrag(tabElips[12,0], tabElips[12,1], 25,
           25, 1, katElips, 0,4, tabElips[13,0], tabElips[13,1]);
     { elipsy male }
     elipsa(tabElips[14,0], tabElips[14,1], 50, 25, 1, katElips,
            0, 0, stopien, tabElips[17,0], tabElips[17,1]);
     elipsa(tabElips[16,0], tabElips[16,1], 50, 25, 1, katElips,
            0, 0, stopien, tabElips[17,0], tabElips[17,1]);
    end;
   delay(20);
   end;
  { Narysuj koncowe linie tworzace duzy trojkat }
  Line(tabElips[10,0], tabElips[10,1], tabElips[6,0], tabElips[6,1]);
  Line(tabElips[10,0], tabElips[10,1], tabElips[8,0], tabElips[8,1]);
  Line(tabElips[8,0], tabElips[8,1], tabElips[6,0], tabElips[6,1]);
  Line(tabElips[6,0], tabElips[6,1], tabT[1,0], tabT[1,1]);
  Line(tabElips[8,0], tabElips[8,1], tabT[2,0], tabT[2,1]);
  Delay(3000);
end;
end.
