{***********************************}
{* Mensfeld Maciej IIIB            *}
{* 23.02.2007                      *}
{* Obracajacy sie szescian         *}
{***********************************}

unit uSzescian;
interface
 type
  Rozmiar = array[0..3, 0..1] of integer;

 procedure okreslRogi
           (kat : integer; stopien : real; var tabX, tabY : Rozmiar);

 procedure rysujSciane
           (kat : integer; nrSciany : byte; tabX, tabY : Rozmiar);

 procedure rysujBoki
           (kolor : byte; kat : integer; tabX, tabY : Rozmiar);

 procedure ustalKolorIRysuj
           (kolor, kat, nrSciany : integer; tabX, tabY : Rozmiar);

 procedure szescian
           (obroty : byte);

implementation
 uses Crt, Graph;




 { --------------------------- Okresl rogi --------------------------------- }
procedure okreslRogi
          (kat : integer; stopien : real; var tabX, tabY : Rozmiar);
const
 r = 45800;                 { odleglosc rogu od punktu obrotu }
var
 indeksX, indeksY : byte;
 punktObrotu : array[0..1, 0..1] of integer;
begin
   indeksX := 0;
   indeksY := 0;
   { punkty srodkowe - "os" obrotu - pierwszy wiersz wart. OX, drugi OY,
     pierwsza kolumna punkt przedni, druga tylni }
   punktObrotu[0,0] := 400;           { X przod }
   punktObrotu[1,0] := 450;           { X tyl   }
   punktObrotu[0,1] := 400;           { Y przod }
   punktObrotu[1,1] := 350;           { Y tyl   }
   { --------------------------- PRZEDNIE ROGI ---------------------------- }
          { okresl polozenie punktu po przeksztalceniu go o dany kat }
{ Punkt poczatkowo gorny lewy }
   tabX[indeksX, indeksY] := Round(punktObrotu[0, 0] +
                                      Sqrt(r) * sin((kat - 135) * stopien));
   tabY[indeksX, indeksY] := Round(punktObrotu[0, 0] +
                                      Sqrt(r) * cos((kat - 135) * stopien));
   Inc(indeksX);
{ Punkt poczatkowo gorny prawy }
   tabX[indeksX, indeksY] := Round(punktObrotu[0, 0] +
                                      Sqrt(r) * sin((kat + 135) * stopien));
   tabY[indeksX, indeksY] := Round(punktObrotu[0, 1] +
                                      Sqrt(r) * cos((kat + 135) * stopien));
   Inc(indeksX);
{ Punkt poczatkowo dolny prawy }
   tabX[indeksX, indeksY] := Round(punktObrotu[0, 0] +
                                      Sqrt(r) * sin((kat + 45) * stopien));
   tabY[indeksX, indeksY] := Round(punktObrotu[0, 1] +
                                      Sqrt(r) * cos((kat + 45) * stopien));
   Inc(indeksX);
{ Punkt poczatkowo dolny lewy }
   tabX[indeksX, indeksY] := Round(punktObrotu[0, 0] +
                                      Sqrt(r) * sin((kat - 45) * stopien));
   tabY[indeksX, indeksY] := Round(punktObrotu[0, 1] +
                                      Sqrt(r) * cos((kat - 45) * stopien));
   { --------------------------- TYLNIE ROGI ------------------------------ }
          { okresl polozenie punktu po przeksztalceniu go o dany kat }
   indeksX := 0;
   Inc(indeksY); { "przejdz" na tylnie rogi" }
{ Punkt poczatkowo gorny lewy }
   tabX[indeksX, indeksY] := Round(punktObrotu[1, 0] +
                                      Sqrt(r) * sin((kat - 135) * stopien));
   tabY[indeksX, indeksY] := Round(punktObrotu[1, 1] +
                                      Sqrt(r) * cos((kat - 135) * stopien));
   Inc(indeksX);
{ Punkt poczatkowo gorny prawy }
   tabX[indeksX, indeksY] := Round(punktObrotu[1, 0] +
                                      Sqrt(r) * sin((kat + 135) * stopien));
   tabY[indeksX, indeksY] := Round(punktObrotu[1, 1] +
                                      Sqrt(r) * cos((kat + 135) * stopien));
   Inc(indeksX);
{ Punkt poczatkowo dolny prawy }
   tabX[indeksX, indeksY] := Round(punktObrotu[1, 0] +
                                      Sqrt(r) * sin((kat + 45) * stopien));
   tabY[indeksX, indeksY] := Round(punktObrotu[1, 1] +
                                      Sqrt(r) * cos((kat + 45) * stopien));
   Inc(indeksX);
{ Punkt poczatkowo dolny lewy }
   tabX[indeksX, indeksY] := Round(punktObrotu[1, 0] +
                                      Sqrt(r) * sin((kat - 45) * stopien));
   tabY[indeksX, indeksY] := Round(punktObrotu[1, 1] +
                                      Sqrt(r) * cos((kat - 45) * stopien));
end; { ----------------------- koniec okresl rogi ------------------------- }


{ ----------------------------- rysujSciane ------------------------------- }
procedure rysujSciane(kat : integer; nrSciany : byte; tabX, tabY : Rozmiar);
{ -- nrSciany = przod --> 0, tyl --> 1 -- }
begin
     if nrSciany = 1 then                    { jesli sciana tylnia }
      if (kat > 45) and (kat < 225) then     { gdy linia "tylnia" }
       SetLineStyle(DashedLn,0,3);           { styl linii - przerywana }
     line(tabX[0, nrSciany], tabY[0, nrSciany],
                                     tabX[1, nrSciany], tabY[1, nrSciany]);
                                             {jesli przednia - rysuj ciagla }
     SetLineStyle(SolidLn,0,3);              { styl linii - ciagla }
     if nrSciany = 1 then                    { jesli sciana tylnia }
      if (kat > 135) and (kat < 315) then    { gdy linia "tylnia" }
       SetLineStyle(DashedLn,0,3);           { styl linii - przerywana }
     line(tabX[1, nrSciany], tabY[1, nrSciany],
                                     tabX[2, nrSciany], tabY[2, nrSciany]);
     SetLineStyle(SolidLn,0,3);              { styl linii - ciagla }
     if nrSciany = 1 then                    { jesli sciana tylnia }
      if (kat < 135) or ((kat > 315) and (kat <= 360)) then
       SetLineStyle(DashedLn,0,3);           { styl linii - przerywana }
     line(tabX[3, nrSciany], tabY[3, nrSciany],
                                     tabX[0, nrSciany] , tabY[0, nrSciany]);
     SetLineStyle(SolidLn,0,3);              { styl linii - ciagla }
     if nrSciany = 1 then                    { jesli sciana tylnia }
      if ((kat >= 0) and (kat < 45)) or ((kat <= 360) and (kat > 230)) then
       SetLineStyle(DashedLn,0,3);           { styl linii - przerywana }
     line(tabX[3, nrSciany], tabY[3, nrSciany],
                                     tabX[2, nrSciany], tabY[2, nrSciany]);
     SetLineStyle(SolidLn,0,3);
end; { ---------------------- koniec rysujSciane ---------------------------}

{ --------------------------- rysujBoki ------------------------------------}
procedure rysujBoki(kolor : byte; kat : integer; tabX, tabY : Rozmiar);
begin
 setcolor(kolor);                            { ustaw kolor }
 { Bok 1 }
 if (kat > 45) and (kat < 135) then          { jesli bok "z tylu" ... }
  SetLineStyle(DashedLN,0,3);                { styl linii - przerywana }
 line(tabX[0,0], tabY[0,0], tabX[0,1], tabY[0,1]);
 SetLineStyle(SolidLn,0,3);

 { Bok 2 }
 if (kat >135) and (kat < 225) then          { jesli bok "z tylu" ... }
  SetLineStyle(DashedLn,0,3);                { styl linii - przerywana }
 line(tabX[1,0], tabY[1,0], tabX[1,1], tabY[1,1]);
 SetLineStyle(SolidLn,0,3);

 { Bok 3 }
 if (kat > 225) and (kat < 315) then         { jesli bok "z tylu" ... }
  SetLineStyle(DashedLN,0,3);                { styl linii - przerywana }
 Line(tabX[2,0], tabY[2,0], tabX[2,1], tabY[2,1]);
 SetLineStyle(SolidLn,0,3);

 { Bok 4 }
 if (kat > 0) and (kat < 45)  then           { jesli bok "z tylu" ... }
  SetLineStyle(DashedLn,0,3);                { styl linii - przerywana }
 if (kat > 315) and (kat <= 360) then        { jesli bok "z tylu" ... }
  SetLineStyle(DashedLn,0,3);                { styl linii - przerywana }
 Line(tabX[3,0], tabY[3,0], tabX[3,1], tabY[3,1]);
 SetLineStyle(SolidLn,0,3);                  { styl linii - ciagla }
end;

{ --------------------------- ustalKoloriRysuj ---------------------------- }
procedure ustalKolorIRysuj(kolor, kat, nrSciany : integer;
                                                        tabX, tabY : Rozmiar);
begin
 setcolor(kolor); { ustaw kolor sciany }
 rysujSciane(kat, nrSciany, tabX, tabY); { polacz "rogi" i stworz sciane }
end;

{ --------------------------- rysuj --------------------------------------- }
procedure szescian(obroty : byte); { ----------- rysujemy ... ------------}
var
 tabX : Rozmiar;                   { tablica wartosci "rogow" w OX kwadratu }
 tabY : Rozmiar;                   { tablica wartosci "rogow" w OY kwadratu }
 kat, katobrotu : integer; { odleglosc od punktu srodkowego w osiach OX i OY}
 kObrotu, licznik : integer;
const
 stopien = (2 * Pi) / 360;         { wartosc 1 stopnia w radianach }
begin
 repeat { powtarzaj...}
  katobrotu := Round(360);         { ilosc obrotow }
  for kat := 0 to katobrotu do     { od zera do 360 stopni ... }
   begin
{ przed kazdym krokiem usun poprzedni szescian }
    Clearviewport;
    SetLineStyle(SolidLn,0,3); { styl linii - ciagla }
{ oblicz wspolrzedne rogow w zaleznosci od kata obrotu }
    okreslRogi(kat, stopien, tabX, tabY);
{ ustal kolor, rysuj tylnia }
    ustalKolorIRysuj(4, kat, 1, tabX, tabY);
{ ustal kolor, rysuj przednia }
    ustalKolorIRysuj(1, kat, 0, tabX, tabY);
{ narysuj boki w zaleznosci od polozenia }
    rysujBoki(1, kat, tabX, tabY);
{ spowolnij zeby nie "mrugalo " tak bardzo... }
    Delay(20);
    Inc(kObrotu);
   end;
 until kObrotu >= obroty * 360; { dopoki nie wykona "obroty" obrotow }
end; { --------------------- koniec rysuj --------------------------------- }

end.
