{**********************************************}
{* Mensfeld Maciej IIIB                       *}
{* 11.03.2007                                 *}
{* Wyswietlanie nieprzecinajacych sie okregow *}
{**********************************************}


program Okregi;

uses Crt, Math, graph;

{$r-} { dyrektywa wylaczajaca sprawdzanie zakresu tablic }

{ pascal nie ma tablic dynamicznych wiec jedyny sposob to tablica
  wskaznikowa ktorej rozmiar odpowiada rozmiarowi typ * ilosc komorek }
type
 tTab = array[0..0, 0..2] of integer;
 tTabOkr = ^tTab;         { taka "sztuczka" zeby moc deklarowac tablice
                               wskaznikowa jako parametr }
var
 tOkregi : tTabOkr;         { tablica wspolrzednych okregow (x, y, r )}
 ilosc : integer;           { ilosc okregow }
 sterownik, tryb, i : integer;
 maxX, maxY : integer;      { przechowuja rozdzielczosc ekranu }


{ --------------------------- POBIERZ ILOSC ------------------------------- }
procedure pobierzIlosc(var liczba : integer);
begin
 ClrScr;
 GotoXY(20, 8 );
 Write('Wprowadz ilosc okregow: ');
 Readln(liczba);
 Dec(liczba);
 while liczba < 0 do
  begin
   GotoXY(20, 8);
   ClrEol;
   Write(' Podaj liczbe wieksza od zera : ');
   Readln(liczba);
   Dec(liczba)
  end;
end;
{ --------------------------- KONIEC POBIERZ ILOSC ------------------------ }


{ --------------------------- START --------------------------------------- }
procedure start(x, y : integer);
begin
 settextstyle(1,horizdir,2); { ustal styl tekstu (czcionka, poziom, rozmiar)}
 OutTextXY(x div 2 - 150, y div 2 - 200, 'Mensfeld Maciej ');
 OutTextXY(x div 2 - 150, y div 2 - 150 , 'Okregi ');
 Delay(2000);
 Clearviewport;
end;
{ --------------------------- KONIEC START -------------------------------- }


{ --------------------------- INICJUJ MODUL GRAPH ------------------------- }
procedure inicjujModulGraph; { inicjuj modul graficzny }
begin
 sterownik:=0;
 InitGraph(sterownik, tryb, '');
 if GraphResult <> 0 then
  begin
   Writeln('Blad grafiki');  { wyswietl blad }
   Halt;
  end;
end;
{ --------------------------- KONIEC INICJUJ MODUL GRAPH ------------------ }


{ --------------------------- USTAL ROZMIAR EKRANU ------------------------ }
procedure ustalRozmiarEkranu(var x , y : integer);
begin
 x := GetMaxX;
 y := GetMaxY;
end;
{ --------------------------- KONIEC USTAL ROZMIAR EKRANU ----------------- }


{ --------------------------- INICJUJ TABLICE ----------------------------- }
procedure inicjujTablice(liczba : integer; var tab : tTabOkr);
begin
    getmem(tab, sizeof(integer) * 3 * liczba);
    { "rezerwuje" miejsce w pamieci dla tablicy o rozmiarze 3 * (3 wiersze)
      * ilosc elementow * typ zmiennej }
end;
{ --------------------------- KONIEC INICJUJ TABLICE ---------------------- }

{ --------------------------- ZABIJ TABLICE ------------------------------- }
procedure zabijTablice(liczba : integer; var tab : tTabOkr);
begin
    freemem(tab, sizeof(integer) * 3 * liczba);
    { "czysci" obszar pamieci wczesniej przydzielony tablicy }
end;
{ --------------------------- KONIEC ZABIJ TABLICE ------------------------ }



{ --------------------------- ODLEGLOSC SRODKOW OKREGOW ------------------- }
function odl(nrOkr1, nrOkr2 : integer; tab :tTabOkr) : integer;
var
 xS, yS : integer;           { x i y srodkowe }
begin
 xS := Abs(tab^[nrOkr1, 0] - tab^[nrOkr2, 0]);
 yS := Abs(tab^[nrOkr1, 1] - tab^[nrOkr2, 1]);
 odl := Floor(Sqrt(Sqr(xS) + Sqr(yS))); { pitagoras }
                             { Floor - zaokraglaj w dol }
end;
{ --------------------------- KONIEC ODLEGLOSC SRODKOW OKREGOW ------------ }


{ --------------------------- CZY PRZECINA -------------------------------- }
function czyPrzecina(indeksKon : integer; tab : tTabOkr) : boolean;
var
 indeks : integer;           { indeks elementu w "x" (kolejny element }
 r1 : integer;           { promienie okregow }
 ilPrzec : integer;          { ilosc "przeciec" z innymi okregami }
 r2 : ^integer;
begin
 if indeksKon = 0 then       { jesli jest tylko jeden okrag }
  ilPrzec := 0               { nie przecina sie z zadnym }
 else                        { jesli jest wiecej niz jeden okrag }
  begin
  ilPrzec := 0;              { zakladamy ze nie przecina sie z zadnym }
   for indeks := 0 to indeksKon - 1 do  { sprawdz dla okregow ilosc - 1 }
    begin                               { nie sprawdzaj dla siebie samego }
     New(r2);                            { "przypisz" miejsce w pamieci }
     r1 := tab^[indeks, 2];  { przyjmij za r1 promien okrego "indeks" }
     r2^ := tab^[indeksKon, 2];{ przyjmi za r2 promien okregu sprawdzanego }
     { jesli sie przecinaja lub jeden zawiera sie w drugim }
     if r1 + r2^ >= odl(indeks, indeksKon, tab) then
      { sprawdz ktory promien wiekszy... }
      if r1 < r2^ then
       begin
        { jesli promien mniejszego + odleglosc srodkow wieksza niz promien
          drugiego }
        if r1 + odl(indeks, IndeksKon , tab) >= r2^ then
         Inc(ilPrzec);       { powieksz ilosc przeciec o 1 }
       end
      else { jesli pierwszy promien wiekszy }
       { sprawdz czy sie zawiera czy przecina }
       if r2^ + odl(indeks, indeksKon, tab) >= r1 then
        Inc(ilPrzec);        { powieksz ilosc przeciec o 1 }
    end;
   Dispose(r2);              { zwolnij miejsce w pamieci }
  end;
 { jesli ilosc przeciec wieksza niz 0 wtedy }
 if ilPrzec > 0 then
  czyPrzecina := true        { zwroc wartosc prawda }
 else                        { w przeciwnym razie ... }
   czyPrzecina := false;     {  zwroc wartosc falsz }
{ stosowanie zliczania ilosci przeciec wynika z potrzeby  "zachowania"
  czy byly jakies przeciecia w poprzednich okregach przed sprawdzeniem
  nastepnego, czego nie da sie zrealizowac samym prawda falsz }
end;
{ --------------------------- KONIEC CZY PRZECINA ------------------------- }


{ --------------------------- USTAL OKREGI -------------------------------- }
procedure ustalOkrag(licznik, x, y : integer; var tab : tTabOkr);
var
 xS, yS, r : integer;        { wspolrzedne srodka oraz promien okregu }
begin
 repeat                      { losuj dane o okregu dopoki ... (A1)}
  xS := Random(x - 12) + 6;
  yS := Random(y - 12) + 6;
  r := Random((y div 2) - 10) + 5;
  { jesli okrag bedzie wychodzil poza ekran w osi OY }
  while ((xS - r) <= 0) or ((xS + r) >= x) do
   { znajdz taki promien dla ktorego nie wyjdzie poza ekran w osi OX }
   r := Random((y div 2) - 10) + 5;
  { jesli okrag bedzie wychodzil poza ekran w osi OY }
  while ((yS - r) <= 0) or ((yS + r) >= y) do
   { znajdz taki promien dla ktorego nie wyjdzie poza ekran w osi OY }
   r := Random((y div 2) - 10) + 5;
                             { "wrzuc" wylosowane wartosci do tablicy }
  tab^[licznik, 0] := xS;
  tab^[licznik, 1] := yS;
  tab^[licznik, 2] := r;
 {(A1) ... dopoki okrag wylosowany przecina ktorys z poprzednich }
 until not czyPrzecina(licznik,tOkregi)
end;
{ --------------------------- KONIEC USTAL OKREGI ------------------------- }


{ --------------------------- SPRAWDZ I RYSUJ ----------------------------- }
procedure sprawdzIRysuj(liczba, x , y : integer; var tab : tTabOkr);
var
 indeks : integer;
begin
 for indeks := 0 to liczba  do
  begin
   ustalOkrag(indeks, x, y, tOkregi);
   Circle(tOkregi^[indeks,0], tOkregi^[indeks,1], tOkregi^[indeks,2]);
  end;
end;
{ --------------------------- KONIEC SPRAWDZ I RYSUJ ---------------------- }


{ --------------------------- ZAPISZ DANE O OKREGACH ---------------------- }
procedure zapiszDane (ilosc : integer; tab : tTabOkr);
var
 plik : text;
 licznik : integer;
const
 nazwaPliku = 'daneOkregow.txt';

begin
 assign(plik, nazwaPliku); { przypisanie nazwy zmiennej plikowej }
 rewrite(plik);            { utworzenie (jesli jest to wyzerowanie ) pliku }
 for licznik := 0 to ilosc do  { wypisz dane o okregach }
  begin
   write(plik,' Okrag numer: ');
   writeln(plik, licznik + 1);
   write(plik,' ');
   write(plik, tab^[licznik,0]);
   writeln(plik,' - polozenie w OX');
   write(plik,' ');
   write(plik, tab^[licznik,1]);
   writeln(plik,' - polozenie w OY');
   write(plik,' ');
   write(plik, tab^[licznik,2]);
   writeln(plik,' - promien');
   writeln(plik,'<--------------------->');
  end;
 Close(plik);              { zamknij plik }
end;
{ --------------------------- KONIEC ZAPISZ DANE O OKREGACH --------------- }

begin
 pobierzIlosc(ilosc);
 inicjujmodulGraph;
 ustalRozmiarEkranu(maxX ,maxY);
 start(maxX, maxY);
 inicjujTablice(ilosc, tOkregi);
 sprawdzIRysuj(ilosc, maxX, maxY, tOkregi);
 zapiszDane(ilosc, tOkregi);
 zabijTablice(ilosc, tOkregi);
 delay(3500);
end.
